#####################################################
# E-Blah Bulliten Board Systems  -  Platinum Series #
#####################################################
# Copyright (c) 2001 - 2006 E-Blah.                 #
#####################################################

VerifyBoard();
CoreLoad('Stats',1);

sub Stats {
	if($URL{'a'} eq 'whereis') { WhereIs(); }
	if(!$uextlog) { error($statstxt[1]); }
	if($hideelog) { is_admin(); }

	# Open the member list, and get all the members into a nice table we can look at later
	fopen(FILE,"$members/List2.txt");
	@memlist = <FILE>;
	fclose(FILE);
	chomp @memlist;
	$totalmembers = @memlist;
	$totalmembers = MakeComma($totalmembers);
	foreach(@memlist) {
		($un,$t,$pc,$reg) = split(/\|/,$_);
		push(@maxmempcount,"$pc|$_");  # User post count max variable
		push(@newmembers,  "$reg|$_"); # When user reg'd
	}
	@maxmempcount = sort{$b <=> $a} @maxmempcount;
	@newmembers   = sort{$b <=> $a} @newmembers;

	# Open the max log to find on what date the most users logged on was
	fopen(FILE,"$prefs/MaxLog.txt");
	@maxlogged = <FILE>;
	fclose(FILE);
	chomp @maxlogged;
	$maxtime = get_date($maxlogged[1]);

	# Find how many active users there are (online ppl)
	fopen(FILE,"$prefs/Active.txt");
	while(<FILE>) { ++$active; }
	fclose(FILE);

	# If click log is enabled, open it and find how many clicks there are
	if($eclick) {
		$clicklog = 0;
		fopen(FILE,"$prefs/ClickLog.txt");
		@clicklog = <FILE>;
		fclose(FILE);
		chomp @clicklog;
		$clicklogc = @clicklog;
		if($logcnt > 59) { $logcnt = sprintf("%.0f",($logcnt/60))." $gtxt{'3'}"; }
			else { $logcnt = "$logcnt $gtxt{'2'}"; }
	}

	# Open all the states files and compile that info for later use
	opendir(DIR,"$prefs/BHits");
	@crap = readdir(DIR);
	closedir(DIR);

	($t,$t,$t,$day,$month,$year) = localtime(time);
	$tempper = $day.$month.$year;

	foreach $junk (@crap) {
		if($junk !~ /.txt/ || $junk eq "$tempper.txt" || $junk eq "quickdb.txt") { next; }

		fopen(FILE,"$prefs/BHits/$junk");
		@junk2 = <FILE>;
		fclose(FILE);
		chomp @junk2;

		unlink("$prefs/BHits/$junk");

		$junk =~ s/.txt\Z//g;
		push(@database,"$junk|$junk2[0]|$junk2[1]|$junk2[2]|$junk2[3]|$junk2[4]|$junk2[5]|$junk2[6]|$junk2[7]");
	}

	fopen(DATABASE,"$prefs/BHits/quickdb.txt");
	@hits = <DATABASE>;
	fclose(DATABASE);
	chomp @hits;

	foreach(@hits) { ($t) = split(/\|/,$_); $taken{$t} = 1; }

	fopen(DATABASE,">>$prefs/BHits/quickdb.txt");
	foreach(@database) {
		($t) = split(/\|/,$_);
		print DATABASE "$_\n" if(!$taken{$t});
		push(@hits,"$_") if(!$taken{$t});
	}
	fclose(DATABASE);

	fopen(FILE2,"$prefs/BHits/$tempper.txt");
	@junk2 = <FILE2>;
	fclose(FILE2);
	chomp @junk2;

	$tempper =~ s/.txt\Z//g;
	push(@hits,"$tempper|$junk2[0]|$junk2[1]|$junk2[2]|$junk2[3]|$junk2[4]|$junk2[5]|$junk2[6]|$junk2[7]");

	foreach(@hits) {
		@hitsL = split(/\|/,$_);

		# Clicks (0) | Threads (1) | Replies (2) | Mems (3) | New Att. (4) | Att. Downloads (5) | Most Online (7)
		$dateinfo{$hitsL[7]} = "$hitsL[1]|$hitsL[2]|$hitsL[3]|$hitsL[4]|$hitsL[5]|$hitsL[6]|$hitsL[8]";

		push(@sortdate,    $hitsL[7]);
		push(@sortclicks,  "$hitsL[1]|$hitsL[7]");
		push(@sortthreads, "$hitsL[2]|$hitsL[7]");
		push(@sortreplies, "$hitsL[3]|$hitsL[7]");
		push(@sortmems,    "$hitsL[4]|$hitsL[7]");
		push(@sortatts,    "$hitsL[5]|$hitsL[7]");
		push(@sortdowns,   "$hitsL[6]|$hitsL[7]");
		push(@sortonline,  "$hitsL[8]|$hitsL[7]");
	}

	@sortdate    = sort{$b <=> $a} @sortdate;
	@sortclicks  = sort{$b <=> $a} @sortclicks;
	@sortthreads = sort{$b <=> $a} @sortthreads;
	@sortreplies = sort{$b <=> $a} @sortreplies;
	@sortmems    = sort{$b <=> $a} @sortmems;
	@sortatts    = sort{$b <=> $a} @sortatts;
	@sortdowns   = sort{$b <=> $a} @sortdowns;
	@sortonline  = sort{$b <=> $a} @sortonline;

	# Lets load the board stats
	BoardStats();

	$title = $statstxt[2];
	header();

	$ebout .= <<"EOT";
<table cellpadding="4" cellspacing="1" class="border" width="950" align="center">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="catbg" align="center"><span class="smalltext"><b>$statstxt[3]</b></span></td>
 </tr><tr>
  <td class="win2">
   <table width="100%">
    <tr>
     <td width="50%"><b><img src="$images/profile_sm.gif"> $statstxt[4]</b></td>
     <td width="50%"><b><img src="$images/open_thread.gif"> $statstxt[5]</b></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win">
   <table width="100%">
    <tr>
     <td width="50%" valign="top">
      <table width="100%">
       <tr>
        <td><b>$statstxt[6]:</b></td>
        <td align="right">$totalmembers $statstxt[32]</td>
       </tr><tr>
        <td><b>$statstxt[8]:</b></td>
        <td align="right">$active $statstxt[31]</td>
       </tr><tr>
        <td colspan="2"><hr size="1" class="hr"></td>
       </tr><tr>
        <td valign="top"><b>$statstxt[9]:</b></td>
        <td align="right">$maxlogged[0] $statstxt[31]<br><font size="1">$maxtime</font></td>
       </tr>
      </table>
     </td>
     <td width="50%">
      <table cellpadding="3" cellspacing="0" width="100%">
EOT
	if($eclick && (!$hideclog || $members{'Administrator',$username})) {
		foreach(@clicklog) {
			($logtime,$ipaddy,$ref,$page,$info) = split(/\|/,$_);
			$f1 = 1;
			if(@ipaddys) { foreach(@ipaddys) { if($_ eq $ipaddy) { $f1 = 0; last; } } }
			if($f1) { push(@ipaddys,$ipaddy); ++$ipcnt; }
		}
		$clicklogc = MakeComma($clicklogc);
		$ebout .= <<"EOT";
       <tr>
        <td valign="top"><b>$statstxt[10] $logcnt:</b></td>
        <td align="right"><a title="$ipcnt $gtxt{'5'}">$clicklogc</a></td>
       </tr>
EOT
	}
	$threads = MakeComma($threads);
	$messagecnt = MakeComma($messagecnt);
	$ebout .= <<"EOT";
       <tr>
        <td valign="top"><b>$gtxt{'6'}:</b></td>
        <td align="right">$catcnt</td>
       </tr><tr>
        <td valign="top"><b>$gtxt{'7'}:</b></td>
        <td align="right">$bdscnt</td>
       </tr><tr>
        <td valign="top"><b>$gtxt{'8'}:</b></td>
        <td align="right">$threads</td>
       </tr><tr>
        <td valign="top"><b>$gtxt{'9'}:</b></td>
        <td align="right">$messagecnt</td>
       </tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr>
EOT
	if($members{'Administrator',$username}) {
		GetSize("$members>1|$messages>1|$prefs|$modsdir|$uploaddir|$boards>1");

		$totalsize = FormatSize($totalsize);

		$ebout .= <<"EOT";
 <tr>
  <td class="catbg" align="center"><span class="smalltext"><b>$statstxt[33]</b></span></td>
 </tr><tr>
  <td class="win2">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
     <td width="50%"><b>$statstxt[34]</b></td>
     <td width="50%"><b>$statstxt[35]</b></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
     <td width="50%" valign="top">
      <table width="100%">
       <tr>
        <td><b>Boards $statstxt[36]:</b></td>
        <td align="right">$size{$boards}</td>
       </tr><tr>
        <td><b>Messages $statstxt[36]:</b></td>
        <td align="right">$size{$messages}</td>
       </tr><tr>
        <td><b>Members $statstxt[36]:</b></td>
        <td align="right">$size{$members}</td>
       </tr><tr>
        <td colspan="2"><hr size="1" class="hr"></td>
       </tr><tr>
        <td><b>$statstxt[37]:</b></td>
        <td align="right">$size{'CORE'}</td>
       </tr>
      </table>
     </td><td width="50%" valign="top">
      <table width="100%">
       <tr>
        <td><b>Prefs $statstxt[36]:</b></td>
        <td align="right">$size{$prefs}</td>
       </tr><tr>
        <td><b>Modifications $statstxt[36]:</b></td>
        <td align="right">$size{$modsdir}</td>
       </tr><tr>
        <td><b>Attachments $statstxt[36]:</b></td>
        <td align="right">$size{$uploaddir}</td>
       </tr><tr>
        <td colspan="2"><hr size="1" class="hr"></td>
       </tr><tr>
        <td><b>$statstxt[38]:</b></td>
        <td align="right">$size{'NOESS'}</td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td colspan="2" align="center"><hr size="1" class="hr"><b>$statstxt[39]:</b> $totalsize</td>
    </tr>
   </table>
  </td>
 </tr>
EOT
	}
	$ebout .= <<"EOT";
 <tr>
  <td class="catbg" align="center"><span class="smalltext"><b>$statstxt[5]</b></span></td>
 </tr><tr>
  <td class="win2">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
     <td width="50%"><b><img src="$images/lamp.gif"> $statstxt[12]</b></td>
     <td width="50%"><b><img src="$images/profile_sm.gif"> $statstxt[28]</b></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win" valign="top">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
EOT
	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		$team = '';
		($posts,$member) = split(/\|/,$maxmempcount[$g]);
		loaduser($member);
		$posts = MakeComma($posts);
		if($member eq '') { next; }
		if($permissions{$membergrp{$member},'team'}) { $team = qq~ <img src="$images/team.gif" alt="$gtxt{'29'}"> ~; }
		$topmems .= qq~<b>$c.</b>$team $userurl{$member} <span class="smalltext">($posts $gtxt{'10'})</span><br>~;
		++$c;
	}
	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		$team = '';
		($regged,$member) = split(/\|/,$newmembers[$g]);
		loaduser($member);
		$regged = get_date($regged);
		if($member eq '') { next; }
		if($permissions{$membergrp{$member},'team'}) { $team = qq~ <img src="$images/team.gif" alt="$gtxt{'29'}"> ~; }
		$regnew .= qq~<b>$c.</b>$team $userurl{$member} ($regged)<br>~;
		++$c;
	}

	$ebout .= <<"EOT";
     <td valign="top" width="50%"><span class="smalltext">$topmems</span></td>
     <td valign="top" width="50%"><span class="smalltext">$regnew</span></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win2">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
     <td width="50%"><b><img src="$images/hotthread.gif"> $statstxt[13]</b></td>
     <td width="50%"><b><img src="$images/veryhotthread.gif"> $statstxt[14] ($gtxt{'12'})</b></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win" valign="top">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
EOT
	foreach $use (@boardbase) {
		($board,$t,$t,$t,$t,$t,$t,$apwbrd) = split('/',$use);
		if(!$boardallow{$board}) { next; }
		fopen(FILE,"$boards/$board.msg");
		while(<FILE>) {
			chomp $_;
			($id,$msub,$t,$t,$replies) = split(/\|/,$_);
			push(@mdata,"$replies|$msub|$id|$board");
		}
		fclose(FILE);
	}
	@mdata = sort{$b <=> $a} @mdata;

	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		($replies,$msub,$id,$bdat) = split(/\|/,$mdata[$g]);
		$replies = MakeComma($replies);
		if($msub) { $toptops .= qq~<b>$c.</b> <a href="$surl\lm-$id/s-$replies/">$msub</a> <span class="smalltext">($replies $gtxt{'12'})</span><br>~; }
		++$c;
	}
	if(!$toptops) { $toptops = $statstxt[15]; }
	@tbds = sort{$b <=> $a} @tbds;

	$c = 1;
	for($g = 0; $g < 10; ++$g) {
		($mcnt,$boardnm,$bid) = split(/\|/,$tbds[$g]);
		$mcnt = MakeComma($mcnt);
		if($boardnm) { $topboards .= qq~<b>$c.</b> <a href="$surl\lb-$bid/">$boardnm</a> <span class="smalltext">($mcnt $gtxt{'11'})</span><br>~; }
		++$c;
	}
	$ebout .= <<"EOT";
     <td valign="top" width="50%"><span class="smalltext">$topboards</span></td>
     <td valign="top" width="50%" colspan="2"><span class="smalltext">$toptops</span></td>
    </tr>
   </table>
  </td>
 </tr>
</table><br>
<table cellpadding="4" cellspacing="1" class="border" width="950" align="center">
 <tr>
  <td class="titlebg" colspan="7" align="center"><span class="smalltext"><b>$statstxt[40]</b></span></td>
 </tr><tr>
EOT
	$stats = 0;
	foreach(@sortdate) {
		($maxclicks,$maxthreads,$maxreplies,$maxmems,$maxnewatt,$maxattdownloads,$maxmostonline) = split(/\|/,$dateinfo{$_});
		($t,$t,$t,$day,$month,$year) = localtime($_);
		$year = $year+1900;

		$maxclicks       = MakeComma($maxclicks) || 1;
		$maxthreads      = MakeComma($maxthreads);
		$maxreplies      = MakeComma($maxreplies);
		$maxmems         = MakeComma($maxmems);
		$maxnewatt       = MakeComma($maxnewatt);
		$maxattdownloads = MakeComma($maxattdownloads);
		$maxmostonline   = MakeComma($maxmostonline);

		$ebout .= <<"EOT";
  <td class="win" width="14%" valign="top">
   <div class="win2" style="padding: 5px;" align="center"><span class="smalltext"><b>$months[$month] $day, $year</b></span></div>
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
     <td class="smalltext" align="right"><b>$maxclicks</b></td>
     <td class="smalltext">$var{'89'}</td>
    </tr><tr>
     <td class="smalltext" align="right"><b>$maxthreads</b></td>
     <td class="smalltext">$statstxt[22]</td>
    </tr><tr>
     <td class="smalltext" align="right"><b>$maxreplies</b></td>
     <td class="smalltext">$gtxt{'38'}</td>
    </tr><tr>
     <td class="smalltext" align="right"><b>$maxmems</b></td>
     <td class="smalltext">$statstxt[41]</td>
    </tr><tr>
     <td class="smalltext" align="right"><b>$maxmostonline</b><br><br></td>
     <td class="smalltext">$statstxt[42]<br><br></td>
    </tr>
EOT
		if($uallow) {
			$ebout .= <<"EOT";
    <tr>
     <td colspan="2" class="win2" align="center" style="padding: 3px;"><span class="smalltext"><b>$statstxt[18]</b></span></td>
    </tr><tr>
     <td class="smalltext" align="right"><b>$maxnewatt</b></td>
     <td class="smalltext">$statstxt[19]</b></td>
    </tr><tr>
     <td class="smalltext" align="right"><b>$maxattdownloads</b></td>
     <td class="smalltext">$gtxt{'14'}</b></td>
    </tr>
EOT
		}

		$ebout .= <<"EOT";
   </table>
  </td>
EOT

		++$stats;
		if($stats == 7) { last; }
	}
	$ebout .= <<"EOT";
 </tr>
</table><br>
<table cellpadding="4" cellspacing="1" class="border" width="950" align="center">
 <tr>
  <td class="titlebg" align="center"><span class="smalltext"><b>$statstxt[43]</b></span></td>
 </tr><tr>
  <td class="win">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td class="win2" align="center" width="150"><b>$statstxt[44]</b></td>
     <td class="win2" align="center" width="185"><b>$var{'89'}</b></td>
     <td class="win2" align="center" width="185"><b>$statstxt[22]</b></td>
     <td class="win2" align="center" width="185"><b>$gtxt{'38'}</b></td>
     <td class="win2" align="center" width="185"><b>$statstxt[41]</b></td>
    </tr>
EOT
	foreach(@sortdate) {
		($maxclicks,$maxthreads,$maxreplies,$maxmems,$maxnewatt,$maxattdownloads,$maxmostonline) = split(/\|/,$dateinfo{$_});
		($t,$t,$t,$t,$month,$yr,$weekday) = localtime($_);

		$cdays{$weekday} += $maxclicks;
		$tdays{$weekday} += $maxthreads;
		$rdays{$weekday} += $maxreplies;
		$mdays{$weekday} += $maxmems;

		if($yr < 101) { next; }
		if(!$tempyearl) { $tempyearl = $yr; }
		$tempyeard = $yr;
		$cmonth{$month,$yr} += $maxclicks;
	}
	$days{$weekday} = MakeComma($days{$weekday});
	if(!$tempyeard) { $tempyeard = 105; }
	if(!$tempyearl) { $tempyearl = 106; }

	for($i = 0; $i < 7; ++$i) {
		$cdays{$i} = MakeComma($cdays{$i});
		$tdays{$i} = MakeComma($tdays{$i});
		$rdays{$i} = MakeComma($rdays{$i});
		$mdays{$i} = MakeComma($mdays{$i});
		$ebout .= <<"EOT";
    <tr>
     <td align="center" class="win2">$days[$i]</td>
     <td align="center">$cdays{$i}</td>
     <td align="center">$tdays{$i}</td>
     <td align="center">$rdays{$i}</td>
     <td align="center">$mdays{$i}</td>
    </tr>
EOT
	}

	$ebout .= <<"EOT";
   </table>
  </td>
 </tr>
</table><br>
<table cellpadding="4" cellspacing="1" class="border" width="950" align="center">
 <tr>
  <td class="titlebg" align="center"><span class="smalltext"><b>$statstxt[46]</b></span></td>
 </tr><tr>
  <td class="win">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td class="win2" align="center"><b>$statstxt[45]</b></td>
     <td class="win2" align="center"><b>$months[0]</b></td>
     <td class="win2" align="center"><b>$months[1]</b></td>
     <td class="win2" align="center"><b>$months[2]</b></td>
     <td class="win2" align="center"><b>$months[3]</b></td>
     <td class="win2" align="center"><b>$months[4]</b></td>
     <td class="win2" align="center"><b>$months[5]</b></td>
     <td class="win2" align="center"><b>$months[6]</b></td>
     <td class="win2" align="center"><b>$months[7]</b></td>
     <td class="win2" align="center"><b>$months[8]</b></td>
     <td class="win2" align="center"><b>$months[9]</b></td>
     <td class="win2" align="center"><b>$months[10]</b></td>
     <td class="win2" align="center"><b>$months[11]</b></td>
    </tr>
EOT
	for($y = $tempyeard; $y <= $tempyearl; ++$y) {
		$ebout .= qq~<tr><td class="win2" align="center">~.(1900+$y)."</td>";
		for($x = 0; $x < 12; ++$x) {
			$cmonth{$x,$y} = MakeComma($cmonth{$x,$y});
			if($cmonth{$x,$y} == 0) { $cmonth{$x,$y} = '-'; }
			$ebout .= <<"EOT";
     <td align="center">$cmonth{$x,$y}</td>
EOT
		}
		$ebout .= "</tr>";
	}
	$ebout .= "</table></td></tr></table>";

	footer();
	exit;
}

sub GetSize { # Gets the database size
	foreach( split(/\|/,$_[0]) ) {
		($directory,$ess) = split(/\>/,$_);
		if($directory eq '') { next; }
		opendir(DIR,"$directory/");
		my @tlist = readdir(DIR);
		closedir(DIR);
		foreach(@tlist) {
			$size{$directory} += -s("$directory/$_");
		}

		$totalsize += $size{$directory};
		if($ess) { $size{'CORE'} += $size{$directory}; } else { $size{'NOESS'} += $size{$directory}; }
		$size{$directory} = FormatSize($size{$directory});
	}
	$size{'CORE'}  = FormatSize($size{'CORE'});
	$size{'NOESS'} = FormatSize($size{'NOESS'});
}

sub FormatSize {
	my $t = $_[0];
	my $type,$bytes;

	$bytes = $t;
	$t = sprintf("%.2f",$t/1024);
	$type = "KB";
	if($t > 1000) { $t = sprintf("%.2f",$t/1024); $type = "MB"; }

	return("$t $type (".MakeComma($bytes)." bytes)");
}

sub BoardStats {
	foreach(@boardbase) {
		($board,$t,$t,$bname,$t,$t,$t,$apwbrd) = split("/",$_);
		if(!$boardallow{$board}) { next; }
		fopen(FILE,"$boards/$board.ino");
		@ino = <FILE>;
		fclose(FILE);
		if(!$ino[1]) { $ino[1] = 0; }
		push(@tbds,"$ino[1]|$bname|$board");
		chomp @ino;
		$threads    += $ino[0];
		$messagecnt += $ino[1];
	}
	$catcnt = $catcounter;
	$bdscnt = $boardcounter;
}

sub WhereIs {
	if(!$whereis) { is_admin(); }
	$title = $whereistxt[1];
	header();
	$ebout .= <<"EOT";
<table class="border" cellpadding="6" cellspacing="1" width="750" align="center">
 <tr>
  <td class="titlebg" colspan="4"><b><img src="$images/clicklog_sm.gif" align="left"> $title</b></td>
 </tr><tr>
  <td class="catbg" align="center" width="30" align="center"><img src="$images/pm2_sm.gif" title="$whereistxt[2]"></td>
  <td class="catbg" align="center" width="170"><b>$whereistxt[3]</b></td>
  <td class="catbg" align="center" width="175"><span class="smalltext"><b>$whereistxt[4]</b></span></td>
  <td class="catbg" align="center" width="375"><b>$gtxt{'15'}</b></td>
 </tr>
EOT
	fopen(FILE,"$prefs/Active.txt");
	while( $active = <FILE> ) {
		chomp $active;
		$member = 2;

		($luser,$ldate,$noshow,$lvis,$oboard,$viewid) = split(/\|/,$active);
		loaduser($luser);
		if($userset{$luser}->[1] || $botsearch{$luser} ne '') { $member = 1; ++$monline; } else { ++$gonline; }
		push(@active,"$member|$ldate|$luser|$noshow|$lvis|$oboard|$viewid");
	}
	fclose(FILE);

	@active = sort {$a <=> $b} @active;

	foreach(@active) {
		($usertype,$ldate,$luser,$noshow,$lvis,$oboard,$viewid) = split(/\|/,$_);
		$pm = '';

		if($usertype != $changetype) {
			$ebout .= qq~<tr><td class="win3" colspan="4"><span class="smalltext"><b>$whereistxt[39] ~;
			if($usertype == 1) { $ebout .= "$monline $whereistxt[40]"; }
			if($usertype == 2) { $ebout .= "$gonline $whereistxt[41]"; }
			$ebout .= "</b></span></tr>";
			$changetype = $usertype;
		}

		if($usertype == 2) { $viewuser = $gtxt{'0'}; }
		elsif($botsearch{$luser} ne '') { $viewuser = qq~<span class="onlinebots">$botsearch{$luser}</span>~; }
		elsif($userset{$luser}->[1] eq '') { $viewuser = $luser; }
			else { $viewuser = $userurl{$luser}; }

		if($usertype == 2 && $members{'Administrator',$username}) { $viewuser = qq~<a href="$surl\lv-admin/a-advipsearch/ip-$luser/">$luser</a>~; }

		$lastact = get_date($ldate);
		$a = 1;

		Map();

		if($userset{$luser}->[1] ne '' && (($username ne 'Guest' && !$noshow) || $members{'Administrator',$username})) { $pm = qq~<a href="$surl\lv-memberpanel/a-pm/s-write/t-$luser/" title="$whereistxt[7] $whereistxt[2]"><img src="$images/pm2_sm.gif" border="0"></a>~; }
		if($a) { $curaction = qq~<a href="$surl\lv-$lvis/">$curaction</a>~; }
		if($noshow && !$members{'Administrator',$username}) { $viewuser = $gtxt{'1'}; }

		$ebout .= <<"EOT";
 <tr>
  <td class="win" align="center" width="30" align="center">$pm</td>
  <td class="win2" align="center">$viewuser</td>
  <td class="win" align="center"><span class="smalltext">$lastact</span></td>
  <td class="win2">$curaction</td>
 </tr>
EOT
	}

	$ebout .= "</table>";
	footer();
	exit;
}

sub Map {
	if($lvis eq 'stats' && $URL{'a'} eq 'whereis') { $curaction = $whereistxt[8]; $a = 0; }
	elsif($lvis eq 'mindex') { $curaction = $whereistxt[10]; BoardLoad(); $a = 0; }
	elsif($lvis eq 'post') { $curaction = $whereistxt[11]; if($viewid eq '') { BoardLoad(); } else { MessageLoad(); } $a = 0; }
	elsif($lvis eq 'admin') { $curaction = $whereistxt[13]; }
	elsif($lvis eq 'login') { $curaction = $whereistxt[14]; if($username ne 'Guest') { $a = 0; } }
	elsif($lvis eq 'mod') { $curaction = $whereistxt[15]; $a = 0; }
	elsif($lvis eq 'register') { $curaction = $whereistxt[16]; if($username ne 'Guest') { $a = 0; } }
	elsif($lvis eq 'print') { $curaction = $whereistxt[17]; $a = 0; }
	elsif($lvis eq 'members') { $curaction = $whereistxt[18]; }
	elsif($lvis eq 'report') { $curaction = $whereistxt[19]; $a = 0; }
	elsif($lvis eq 'cal') { $curaction = $whereistxt[20]; }
	elsif($lvis eq 'download') { $curaction = $whereistxt[21]; $a = 0; }
	elsif($lvis eq 'stats') { $curaction = $whereistxt[22]; $a = 0; }
	elsif($lvis eq 'search') { $curaction = $whereistxt[23]; }
	elsif($lvis eq 'memberpanel') { $curaction = $whereistxt[2]; if($username eq 'Guest') { $a = 0; } }
	elsif($lvis eq 'shownews') { $curaction = $whereistxt[38]; $a = 0; }
	elsif($oboard ne '' && $viewid ne '') { $curaction = $whereistxt[9]; MessageLoad(); $a = 0; }
	elsif($oboard ne '') { $curaction = $whereistxt[10]; BoardLoad(); $a = 0; }
	elsif($lvis eq '') { $curaction = $whereistxt[25]; }
		else { $curaction = $whereistxt[26]; }
}

sub MessageLoad {
	$fast = 1;
	foreach(@msearched) {
		if($_ eq $oboard) { $fast = 0; last; }
	}
	if($fast) {
		push(@msearched,"$oboard");
		if(!$boardallow{$oboard}) { return; }
		fopen(FILE,"$boards/$oboard.msg");
		while(<FILE>) {
			chomp $_;
			($id,$msub) = split(/\|/,$_);
			push(@mdata,"$id|$msub");
		}
		fclose(FILE);
	}
	foreach(@mdata) {
		($id,$msub) = split(/\|/,$_);
		if($id eq $viewid) {
			if($lvis eq 'post') { $curaction = qq~<b>$whereistxt[27]:</b> <a href="$surl\lm-$id/" title="$whereistxt[27] $whereistxt[29]">~.CensorList($msub)."</a>"; }
				else { $curaction = qq~<b>$whereistxt[29]:</b> <a href="$surl\lm-$id/" title="$whereistxt[31] $whereistxt[29]">~.CensorList($msub)."</a>"; }
			last;
		}
	}
}

sub BoardLoad {
	foreach(@boardbase) {
		($id,$t,$t,$bname) = split("/",$_);
		if(!$boardallow{$id}) { return; }
		if($id eq $oboard) {
			if($lvis eq 'post') { $curaction = qq~<b>$whereistxt[11] $whereistxt[34]:</b> <a href="$surl\lb-$oboard/" title="$whereistxt[11] $whereistxt[34] $bname">$bname</a>~; }
				else { $curaction = qq~<b>$whereistxt[37]:</b> <a href="$surl\lb-$oboard/" title="$whereistxt[10]">$bname</a>~; }
			last;
		}
	}
}
1;